setwd("~/mnt/UVa2020_2021/1 Cuatrimestre/Diseo y Evaluacin de Sistemas Interactivos/Laboratorio/Proyecto final/src/data")
d <- read.csv("consumo-de-electricidad-mensual-en-castilla-y-leon.csv")
# Habitantes en 2019 de cada provincia
padron <- c(157640, 356958, 460001, 160980, 330119, 153129, 88636, 519546, 172539)
# Primer grfico
d1 <- aggregate(x = d$Consumo, by = list(d$Mes, d$Provincia), FUN = sum)
colnames(d1) <- c("Mes", "Provincia", "Consumo")
d1$ConsumoHab <- d1$Consumo / rep(padron, each=22)
write.csv(d1, file = "d1.csv", row.names = F, quote = F)

# Segundo grfico
library(reshape2)
tmp <- aggregate(x = d$Consumo, by = list(d$Mes, d$Provincia, d$Suministrador), FUN = sum)
d2.provs <- dcast(data = tmp,formula = Group.1 + Group.2 ~Group.3,fun.aggregate = sum,value.var = "x")
d2.cyl <- dcast(data = tmp,formula = Group.1 ~Group.3,fun.aggregate = sum,value.var = "x")
d2.cyl$Group.2 <- rep("Total", 22)
d2 <- rbind(d2.provs, d2.cyl)
d2$`Endesa Distribucin`+d2$`I-DE`+d2$Viesgo+d2$UFD
a <- apply(d2, 1, function(x){
  sum <- as.numeric(x[3]) +as.numeric(x[4]) +as.numeric(x[5]) +as.numeric(x[6])
  x[3] <- as.numeric(x[3])*100 / sum
  x[4] <- as.numeric(x[4])*100 / sum
  x[5] <- as.numeric(x[5])*100 / sum
  x[6] <- as.numeric(x[6])*100 / sum
  return(x)
})
a <- t(a)
colnames(a) <- c("Mes", "Provincia", "Endesa", "I-DE", "Viesgo", "UFD")
write.csv(a, file = "d2.csv", row.names = F, quote = F)

# Tercer grfico
tmp <- aggregate(x = d$Consumo, by = list(d$Mes, d$Provincia, d$Tipo), FUN = sum)
d3.provs <- dcast(data = tmp,formula = Group.1 + Group.2 ~ Group.3,fun.aggregate = sum,value.var = "x")
d3.cyl <- dcast(data = tmp,formula = Group.1 ~Group.3,fun.aggregate = sum,value.var = "x")
d3.cyl$Group.2 <- rep("Total", 22)
d3 <- rbind(d3.provs, d3.cyl)
colnames(d3) <- c("Mes", "Provincia", "Industrial", "Residencial", "Servicios")
write.csv(d3, file = "d3.csv", row.names = F, quote = F)
