/**
 * @file Archivo principal, continene el punto de entrada de la web
 * @author David Población Criado
 */

 /**
  * Cuando se carga la página
  */
$(document).ready(function () {
    let provincias = ["Ávila", "Burgos", "León", "Palencia", "Salamanca", "Segovia", "Soria", "Valladolid", "Zamora"];
    var tipoConsumo = 0;
    var provincia2 = "Total";
    var provincia3 = "Total";

    // Manejador de tabs
    $('#tabs li a:not(:first)').addClass('inactive');
    $('.container').hide();
    $('.container:first').show();
    $('#tabs li a').click(function () {
        var t = $(this).attr('id');
        if ($(this).hasClass('inactive')) {
            $('#tabs li a').addClass('inactive');
            $(this).removeClass('inactive');

            $('.container').hide();
            $('#' + t + 'C').fadeIn('slow');

            // Cargamos cada tab solo cuando está seleccionada, no antes
            switch (t) {
                case "tab1":
                    d3.select("#serie").selectAll("svg").remove();
                    dibujarGrafico1(provincias, tipoConsumo);
                    break;
                case "tab2":
                    d3.select("#stacked").selectAll("svg").remove();
                    dibujarGrafico2(provincia2);
                    break;
                case "tab3":
                    d3.select("#barChart").selectAll("svg").remove();
                    dibujarGrafico3(provincia3);
                    break;
                case "tab4":
                    d3.select("#mapa").selectAll("svg").remove();
                    dibujarGrafico4("2019-01");
                    break;
            }
        }
    });

    // El tab1 se carga al principio dado que se empieza por él
    d3.select("#serie").selectAll("svg").remove();
    dibujarGrafico1(provincias, tipoConsumo);

    // Gráfico 1
    // Para la selección de las provincias de line chart
    $("input[type=checkbox]").change(function () {
        if (this.checked) {
            provincias.push(this.name);
        } else {
            provincias.splice(provincias.indexOf(this.name), 1);
        }

        d3.select("#serie").selectAll("svg").remove();
        dibujarGrafico1(provincias, tipoConsumo);
    });

    // Para seleccionar si es el consumo por habitante o el total
    $("input[type=radio][name=tipoConsumo]").change(function () {
        tipoConsumo = parseInt($(this).val());
        d3.select("#serie").selectAll("svg").remove();
        dibujarGrafico1(provincias, tipoConsumo);
    });

    // Gráfico 2
    // Para seleccionar si es el consumo por habitante o el total
    $("input[type=radio][name=provincias2]").change(function () {
        provincia2 = $(this).val();
        d3.select("#stacked").selectAll("svg").remove();
        dibujarGrafico2(provincia2);
    });

    // Gráfico 3
    // Para seleccionar si es el consumo por habitante o el total
    $("input[type=radio][name=provincias3]").change(function () {
        provincia3 = $(this).val();
        d3.select("#barChart").selectAll("svg").remove();
        dibujarGrafico3(provincia3);
    });

    // Gráfico 4
    // Selección de la fecha a mostrar en mapa
    $("select").on('change', function () {
        d3.select("#mapa").selectAll("svg").remove();
        dibujarGrafico4(this.value);
    });

    // Modo oscuro
    $("input[type=checkbox][name=oscuro]").change(function () {

        if (this.checked) {
            modoOscuro();
        } else {
            modoClaro();
        }
    });
});

/**
 * Activa el modo oscuro en la web, es decir, pone el fondo negro y todo lo demás
 * en colores claros
 */
function modoOscuro() {
    document.getElementsByTagName("html")[0].style.backgroundColor = "black";
    document.getElementsByTagName("html")[0].style.color = "white";
    document.getElementsByTagName("footer")[0].style.color = "white";
}

/**
 * Activa el modo claro en la web, es decir, pone el fondo blacno y todo lo demás
 * en colores oscuros
 */
function modoClaro() {
    document.getElementsByTagName("html")[0].style.backgroundColor = "white";
    document.getElementsByTagName("html")[0].style.color = "black";
    document.getElementsByTagName("footer")[0].style.color = "black";
}